#
# spec file for package wlan-kmp (Version 1)
#
# Copyright (c) 2009 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           wlan-kmp
BuildRequires:  kernel-source kernel-syms sharutils
%define kernel_version  %(uname -r)
%define at76_version 0.12beta18
%define wlanng_version 0.2.2
%define acx_version 20060113
%define adm_version 20060111
%define rfswitch_version 0.1
%define rt2x00_version 2.0.0-b3
%define rtl_version 20050817
Summary:        Kernel Modules for Wireless LAN Cards
Version:        1
Release:        0.12.42
Group:          System/Kernel
License:        GPL v2 or later
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
#Provides:
#Requires:    
#Conflicts:   
Url:            http://www.hpl.hp.com/personal/Jean_Tourrilhes/Linux/Tools.html
AutoReqProv:    on
Supplements:    modalias(pci:v*d*sv*sd*bc06sc07i00*)
Source10:       at76c503a-%{at76_version}.tar.bz2
Patch10:        at76c503.dif
Patch11:        at76c503-badness.dif
Source30:       linux-wlan-ng-%{wlanng_version}.tar.bz2
Patch30:        linux-wlan-ng.dif
Patch31:        linux-wlan-ng-2.6.14.dif
Patch32:        linux-wlan-ng-2.6.16.dif
Source31:       linux-wlan-ng.config
Source32:       linux-wlan-ng-mkversionh.sh
Source33:       linux-wlan-ng-makefile_main
Source34:       linux-wlan-ng-makefile_p80211
Source35:       linux-wlan-ng-makefile_modules
Source40:       acx-%{acx_version}.tar.bz2
Patch40:        acx.dif
Source60:       adm8211-%{adm_version}.tar.bz2
Patch60:        adm8211.dif
Source70:       rtl8180-sa2400-%{rtl_version}.tar.bz2
Patch70:        rtl8180-sa2400.dif
Patch71:        rtl8180-sa2400-modparm.dif
Patch72:        rtl8180-sa2400_crypto.dif
Source80:       rfswitch-%{rfswitch_version}.tar.bz2
Patch80:        rfswitch.dif
Patch100:       remove-MODULE_PARM.diff
Source100:      preamble
ExclusiveArch:  %ix86 x86_64 ppc ppc64
%suse_kernel_module_package -n wlan -p %_sourcedir/preamble kdump um

%description
This package contains kernel modules for various WLAN adapters.



Authors:
--------
    Jrg Albert <joerg.albert@gmx.d> (at76c503)
    Sam Leffler <sam@errno.com> (madwifi)
    Greg Chesson <madwifi@atheros.com> (madwifi)
    Michael Wu <flamingice@sourmilk.net> (adm8211)
    James Ketrenos <jketreno@linux.intel.com> (ipw2x00)
    Various others

%package -n wlan-KMP
Group:          System/Kernel
License:        GPL v2 or later
Summary:        Kernel Modules for Wireless LAN Cards

%description -n wlan-KMP
This package contains kernel modules for various WLAN adapters.



Authors:
--------
    Jrg Albert <joerg.albert@gmx.d> (at76c503)
    Sam Leffler <sam@errno.com> (madwifi)
    Greg Chesson <madwifi@atheros.com> (madwifi)
    Michael Wu <flamingice@sourmilk.net> (adm8211)
    James Ketrenos <jketreno@linux.intel.com> (ipw2x00)
    Various others

%prep
%setup10 -T -b 10 -n at76c503a-%{at76_version}
%patch10
%patch11 -p1
%setup30 -q -T -b 30 -n linux-wlan-ng-%{wlanng_version}
%patch30
%patch31 -p1
%patch32 -p1
chmod a+x %{SOURCE32}
cp %{SOURCE31} config.mk
cp %{SOURCE32} mkversionh.sh
%setup40 -q -T -b 40 -n acx-%{acx_version}
%patch40
%setup60 -q -T -b 60 -n adm8211
%patch60 -p1
%setup70 -q -T -b 70 -n rtl8180-sa2400-%{rtl_version}
%patch70 -p1
%patch71 -p1
%patch72 -p1
mv -f Makefile26 Makefile
%setup80 -q -T -b 80 -n rfswitch-%{rfswitch_version}
%patch80 -p1
cd %_builddir
%patch100

%build
cd ..
%ifarch %ix86 x86_64
# creating wlanng buildtree
(cd linux-wlan-ng-%{wlanng_version} ; ./mkversionh.sh )
mkdir wlan-ng-%{wlanng_version}
cp -a linux-wlan-ng-%{wlanng_version}/src/mkmeta \
	wlan-ng-%{wlanng_version}
cp -a linux-wlan-ng-%{wlanng_version}/src/p80211 \
	wlan-ng-%{wlanng_version}
cp -a linux-wlan-ng-%{wlanng_version}/src/prism2/driver \
	wlan-ng-%{wlanng_version}/prism2
cp -a linux-wlan-ng-%{wlanng_version}/src/shared \
	wlan-ng-%{wlanng_version}
cp -a linux-wlan-ng-%{wlanng_version}/src/include \
	wlan-ng-%{wlanng_version}
cp -a linux-wlan-ng-%{wlanng_version}/src/prism2/include/prism2 \
	wlan-ng-%{wlanng_version}/include
cp -a %{SOURCE31} \
	wlan-ng-%{wlanng_version}/config.mk
cp -a %{SOURCE32} \
	wlan-ng-%{wlanng_version}/mkversionh.sh
cp %{SOURCE33} wlan-ng-%{wlanng_version}/Makefile
cp %{SOURCE34} wlan-ng-%{wlanng_version}/p80211/Makefile
cp %{SOURCE35} wlan-ng-%{wlanng_version}/prism2/Makefile
make -C wlan-ng-%{wlanng_version}/mkmeta
%endif
rm -rf linux-wlan-ng-%{wlanng_version}
%ifarch ppc ppc64
# disable on ppc, no rdtsc
rm -rf rtl8180-sa2400-%{rtl_version}
%endif
mkdir obj
for flavor in %flavors_to_build; do
  rm -rf obj/$flavor
  mkdir obj/$flavor
  for i in * ; do
     test $i = obj && continue
     cp -r $i obj/$flavor/
     make -C /usr/src/linux-obj/%_target_cpu/$flavor modules \
          M=$PWD/obj/$flavor/$i
  done
done

%install
cd ..
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=updates
k=%kernel_version
kernel_version_=${k%%-*}
for flavor in %flavors_to_build; do
    for i in $PWD/obj/$flavor/* ; do
        make -C /usr/src/linux-obj/%_target_cpu/$flavor modules_install \
         M=$i INSTALL_MOD_DIR=updates.$(basename $i)
    done
    mkdir -p %{buildroot}/lib/modules/${kernel_version_}-$flavor/updates
    mv %{buildroot}/lib/modules/${kernel_version_}-$flavor/updates.*/* \
	%{buildroot}/lib/modules/${kernel_version_}-$flavor/updates/
    rm -r %{buildroot}/lib/modules/${kernel_version_}-$flavor/updates.*
done

%clean
test -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != "/" && rm -rf $RPM_BUILD_ROOT

%changelog
* Mon Apr  6 2009 ro@suse.de
- buildfix: make sure needed files are executable
* Wed Jan 16 2008 ro@suse.de
- fix build with SP2 kernel
* Mon Dec 11 2006 jg@suse.de
- split off ipw3945 from wlan-kmp (fate 301412)
* Tue Jun 20 2006 jg@suse.de
- removed unlock SSID patch (breaks roaming)
* Mon Jun 19 2006 jg@suse.de
- enabled forced disassociation on capability change (bug 177104)
- unlock SSID on disassociation (bug 177104)
- fixed possbile system lockup in ad-hoc mode (bug 184343)
* Fri May 19 2006 jg@suse.de
- ipw3945: update to 1.0.3, changes:
  * Fix problem with using uninitialized crypt pointer during
    shared-key authentication
  * Fix problem with not being able to trun off RTS via iwconfig
  * Fix problem with BUG_ON if duplicate packet recieved w/out
    retry bit
  * Fix problem with not setting privacy bits correctly
  * Fix problem with using uninitialized bssid during association
  * Fix to correctly clear out station table when switching modes
  * Fix to properly set capability bits
  * Set RTS handling to match 802.11 spec
  * Fixed problem with iwconfig ethX power not being able to set
    power to ON
  * Fixed problem with iwlist scan returning that a scan was in
    progress while trying to associate
  * Fixed filters script to look in the correct location for the
    filters file
  * Changed default retry per rate count from 2 to 1 to improve
    throughput
  * Added sysfs entry to manually select new retry pre rate counts
- ipw3945: fixed broken non-WPA association after WPA connection
  (bug 177104)
* Mon Apr 10 2006 agruen@suse.de
- Add preamble `Enhances: kernel-$flavor' workaround to KMP
  sub-packages (156513).
* Fri Apr  7 2006 jg@suse.de
- added PCI class cardbus bridge modalias tag
* Fri Apr  7 2006 jg@suse.de
- ipw3945: update to 0.0.73 (bug 145190), changes:
  * Fixed problem with RSSI having IPW_RSSI_OFFSET being subtracted
    twice (resulting in *very low* signal levels)
  * Fixed #972 problem with not being able to associate to hidden
    SSIDs using wpa_supplicant.
  * Fixed #976 problem with RTS threshold value being clamped at
    2304 vs.  2344.
  * Fixed #933 problem with association to hidden networks timing
    out (increased the timeout from 500ms to 750ms)
  * Merged patch to set 'fixed' flag for the WE get rate handler
  * Added rtap_filter sysfs entry for configuring which packets are
    sent to user space via the rtap interface.
  * Modified the tx and rx byte count statistics to count only
    802.11 data payloads vs. counting miscellaneous 802.11 overhead.
  * Changed single usage of kfree_skb to dev_kfree_skb_any to fix
    a compile problem seen by some users.
  * Fixed problem with timed out host commands reporting the wrong
    command # to the debug log.
  * Added code to wait for an in-progress scan to abort before
    switching modes.
  * Modified scan request to block until the request is acknowledged
    before returning to ensure that the scanning state machine is in
    sync with the hardware state machine.
  * Fix #964 problem with disassociation on hidden networks
  * Fix #956 problem loading driver if RF Kill switch enabled in
    0.0.70
  * Fixed problem with switching from BG to A mode via iwpriv
    set_mode while in an ad-hoc network.
  * Change association timeout value from HZ/2 to 750ms (see #933)
  * Added rtap interface for RF promiscuous mode while associated.
    Enabled via CONFIG_IPW3945_RADIOTAP.
  * Modified rate scaling to not send an unnecessary command to
    the microcode every time the rate changes.
  * Modified the Tx measurement code to only gather statistics once
    every 3 seconds vs. every time a packet exceeds a given size
    (relative to the rate used)
  * Fixed #932 - Modified Tx measurement code to disable BT
    priority for those Tx requests where measurements are being
    requested
- ipw3945: dropped obsolete hidden_ssid and associate_timout
  patches
* Mon Apr  3 2006 agruen@suse.de
- convert-MODULE_PARM.diff: Convert from the obsolete MODULE_PARM
  to the new module_param.
* Wed Mar 29 2006 jg@suse.de
- ipw3945: replaced association timeout patch with upstream fix
  (bug 145190)
- ipw3945: added support to scan for hidden SSIDs using
  wpa_supplicant (bug 145190)
* Sun Mar 26 2006 ro@suse.de
- do not build rtl8100 on ppc (no rdtsc)
* Wed Mar 22 2006 jg@suse.de
- ipw3945: update to 1.0.0 (bug 145190, no code changes,
  documentation update only)
* Fri Mar  3 2006 jg@suse.de
- increased association timeout (fixes association to networks
  with hidden ESSIDs)
* Mon Feb 27 2006 jg@suse.de
- ipw3945: update to 0.0.69 (bug 145190)
* Thu Feb 23 2006 jg@suse.de
- copying installed modules around to avoid 'make modules_install'
  delete them
- removed broken rt2x00 driver (bug 149141)
* Mon Feb 13 2006 jg@suse.de
- rtl8180-sa2400: fixed module params
- ipw3945: update to 0.63 (bug 145190)
* Fri Feb 10 2006 jg@suse.de
- split off wlan drivers in their own package
- removed dependency on kernel-source
- linux-wlan-ng: removed prism2dl.c from tarball (bug 148715)
